<?php
/************************************************************************
Access_user Class ver. 1.86
Easy to use class to protect pages and register users

Copyright (c) 2004 - 2005, Olaf Lederer
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of the finalwebsites.com nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

_________________________________________________________________________
available at http://www.finalwebsites.com 
Comments & suggestions: http://www.finalwebsites.com/contact.php
If you need help check this forum too:
http://olederer.users.phpclasses.org/discuss/package/1906/

*************************************************************************/

function mysqli_result($res,$row=0,$col=0){
    $numrows = mysqli_num_rows($res);
    if ($numrows && $row <= ($numrows-1) && $row >=0){
        mysqli_data_seek($res,$row);
        $resrow = (is_numeric($col)) ? mysqli_fetch_row($res) : mysqli_fetch_assoc($res);
        if (isset($resrow[$col])){
            return $resrow[$col];
        }
    }
    return false;
}

session_start();
// error_reporting (E_ALL); // I use this only for testing
require($config['rootdir']."/config.php"); // this path works for me...
require($config['rootdir']."/classes/access_user/db_config.php"); // this path works for me...
require($config['rootdir']."/language/".$config['language']."/main.php"); // this path works for me...

$link;

class Access_user {
	
	var $table_name = "users"; 
	var $user;
	var $user_pw;
	var $access_level;
	var $user_full_name;
	var $user_info;
	var $user_email;
	var $save_login = "no";
	var $cookie_name = COOKIE_NAME;
	var $cookie_path = COOKIE_PATH; 
	var $is_cookie;
	
	var $count_visit;
	
	var $id;
	var $language = LANGUAGE; // change this property to use messages in another language 
	var $the_msg;
	var $login_page;
	var $main_page;
	var $password_page;
	var $deny_access_page;
	var $auto_activation = AUTO_ACTIVATION;
	var $send_copy = SEND_COPY; // send a mail copy to the administrator (register only)
	
	var $webmaster_mail = WEBMASTER_MAIL;
	var $webmaster_name = WEBMASTER_NAME;
	var $admin_mail = ADMIN_MAIL;
	var $admin_name = ADMIN_NAME;
	
	function Access_user() {
		$this->connect_db();
		$this->login_page = LOGIN_PAGE;
		$this->main_page = START_PAGE;
		$this->password_page = ACTIVE_PASS_PAGE;
		$this->activate_acount_page = ACTIVATE_ACOUNT_PAGE;
		$this->deny_access_page = DENY_ACCESS_PAGE;
		$this->admin_page = ADMIN_PAGE;
	}	
	function check_user($pass = "") {
           global $link;
		switch ($pass) {
			case "new": 
			$sql = sprintf("SELECT COUNT(*) AS test FROM %s WHERE login = '%s' OR email = '%s'", $this->table_name, $this->user, $this->user_email);
			break;
			case "lost":
			$sql = sprintf("SELECT COUNT(*) AS test FROM %s WHERE email = '%s' AND active = 'y'", $this->table_name, $this->user_email);
			break;
			case "new_pass":
			$sql = sprintf("SELECT COUNT(*) AS test FROM %s WHERE pw = '%s' AND id = %d", $this->table_name, $this->user_pw, $this->id);
			break;
			case "active":
			$sql = sprintf("SELECT COUNT(*) AS test FROM %s WHERE id = %d AND active = 'n'", $this->table_name, $this->id);
			break;
			case "validate":
			$sql = sprintf("SELECT COUNT(*) AS test FROM %s WHERE id = %d AND tmp_mail <> ''", $this->table_name, $this->id);
			break;
			default:
			$password = (strlen($this->user_pw) < 32) ? md5($this->user_pw) : $this->user_pw;
			$sql = sprintf("SELECT COUNT(*) AS test FROM %s WHERE BINARY login = '%s' AND pw = '%s' AND active = 'y'", $this->table_name, $this->user, $password);
		}
		$result = $link->query($sql) or die(mysqli_error($link));
		if (mysqli_result($result, 0, "test") != 0) {
			return true;
		} else {
			return false;
		}
	}
	// New methods to handle the access level	
	function get_access_level() {
           global $link;
		$sql = sprintf("SELECT access_level FROM %s WHERE login = '%s' AND active = 'y'", $this->table_name, $this->user);
		if (!$result = $link->query($sql)) {
		   $this->the_msg = $this->messages(14);
		} else {
			$this->access_level = mysqli_result($result, 0, "access_level");
		}
	}
	function set_user() {
		$_SESSION['user'] = $this->user;
		$_SESSION['pw'] = $this->user_pw;
		if (isset($_SESSION['referer']) && $_SESSION['referer'] != "") {
			$next_page = $_SESSION['referer'];
			unset($_SESSION['referer']);
		} else {
			$next_page = $this->main_page;
		}
		header("Location: ".$next_page);
	}
	function connect_db() {
           global $link;
		global $config;
		$link = mysqli_connect($config['dbhost'], $config['dbuser'], $config['dbpass'],$config['dbname']);
	}
	function login_user($user, $password) {
		if ($user != "" && $password != "") {
			$this->user = $user;
			$this->user_pw = $password;
			if ($this->check_user()) {
				$this->login_saver();
				if ($this->count_visit) {
					$this->reg_visit($user, $password);
				}
				$this->set_user();
			} else {
				$this->the_msg = $this->messages(10);
			}
		} else {
			$this->the_msg = $this->messages(11);
		}
	}
	function login_saver() {
		if ($this->save_login == "no") {
			if (isset($_COOKIE[$this->cookie_name])) {
				$expire = time()-3600;
			} else {
				return;
			}
		} else {
			$expire = time()+2592000;
		}		
		$cookie_str = $this->user.chr(31).base64_encode($this->user_pw);
		// setcookie($this->cookie_name, $cookie_str, $expire, $this->cookie_path);
		// never ending cookie
		setcookie($this->cookie_name, $cookie_str, 0, $this->cookie_path);
	}
	function login_reader() {
		if (isset($_COOKIE[$this->cookie_name])) {
			$cookie_parts = explode(chr(31), $_COOKIE[$this->cookie_name]);
			$this->user = $cookie_parts[0];
			$this->user_pw = base64_decode($cookie_parts[1]);
			$this->is_cookie = true;
		}			 
	}
	function reg_visit($login, $pass) {
           global $link;
		$visit_sql = sprintf("UPDATE %s SET extra_info = '%s' WHERE login = '%s' AND pw = '%s'", $this->table_name, date("Y-m-d H:i:s"), $login, md5($pass));
		$link->query($visit_sql);
	}
	function log_out() {
		unset($_SESSION['user']);
		unset($_SESSION['pw']);
		header("Location: ".$this->login_page);
	}
	function access_page($refer = "", $qs = "", $level = DEFAULT_ACCESS_LEVEL) {
		$refer_qs = $refer;
		$refer_qs .= ($qs != "") ? "?".$qs : "";
		if (isset($_SESSION['user']) && isset($_SESSION['pw'])) {
			$this->user = $_SESSION['user'];
			$this->user_pw = $_SESSION['pw'];
			$this->get_access_level();
			if (!$this->check_user()) {
				$_SESSION['referer'] = $refer_qs;
				header("Location: ".$this->login_page);
			}
			if ($this->access_level < $level) {
				header("Location: ".$this->deny_access_page);
			}
		} else { 
			$_SESSION['referer'] = $refer_qs;
			header("Location: ".$this->login_page);
		}
	}
	function get_user_info() {
           global $link;
		$sql_info = sprintf("SELECT real_name, extra_info, email, id FROM %s WHERE login = '%s' AND pw = '%s'", $this->table_name, $this->user, md5($this->user_pw));
		$res_info = $link->query($sql_info);
		$rowres   = @mysqli_fetch_row($res_info);
		
		$this->id = $rowres['3'];
		$this->user_full_name = $rowres['0'];
		$this->user_info = $rowres['1'];
		$this->user_email = $rowres['2'];
	}
	function update_user($new_password, $new_confirm, $new_name, $new_info, $new_mail) {
           global $link;
		if ($new_password != "") {
			if ($this->check_new_password($new_password, $new_confirm)) {
				$ins_password = $new_password;
				$update_pw = true;
			} else {
				return;
			}
		} else {
			$ins_password = $this->user_pw;
			$update_pw = false;
		}
		if (trim($new_mail) <> $this->user_email) {
			if  ($this->check_email($new_mail)) {
				$this->user_email = $new_mail;
				if (!$this->check_user("lost")) {
					$update_email = true;
				} else {
					$this->the_msg = $this->messages(31);
					return;
				}
			} else {
				$this->the_msg = $this->messages(16);
				return;
			}
		} else {
			$update_email = false;
			$new_mail = "";
		}
		$upd_sql = sprintf("UPDATE %s SET pw = %s, real_name = %s, extra_info = %s, tmp_mail = %s WHERE id = %d", 
			$this->table_name,
			$this->ins_string(md5($ins_password)),
			$this->ins_string($new_name),
			$this->ins_string($new_info),
			$this->ins_string($new_mail),
			$this->id);
		$upd_res = $link->query($upd_sql);
		if ($upd_res) {
			if ($update_pw) {
				$_SESSION['pw'] = $this->user_pw = $ins_password;
				if (isset($_COOKIE[$this->cookie_name])) {
					$this->save_login = "yes";
					$this->login_saver();
				}
			}
			$this->the_msg = $this->messages(30);
			if ($update_email) {
				if ($this->send_mail($new_mail, 33)) {
					$this->the_msg = $this->messages(27);
				} else {
					$link->query(sprintf("UPDATE %s SET tmp_mail = ''", $this->table_name));
					$this->the_msg = $this->messages(14);
				} 
			}
		} else {
			$this->the_msg = $this->messages(15);
		}
	}
	function check_new_password($pass, $pw_conform) {
		if ($pass == $pw_conform) {
			if (strlen($pass) >= PW_LENGTH) {
				return true;
			} else {
				$this->the_msg = $this->messages(32);
				return false;
			}
		} else {
			$this->the_msg = $this->messages(38);
			return false;
		}	
	}
	function check_email($mail_address) {
		if (preg_match("/^[0-9a-z]+(([\.\-_])[0-9a-z]+)*@[0-9a-z]+(([\.\-])[0-9a-z-]+)*\.[a-z]{2,4}$/i", $mail_address)) {
			return true;
		} else {
			return false;
		}
	}
	function ins_string($value, $type = "") {
		$value = (!get_magic_quotes_gpc()) ? addslashes($value) : $value;
		switch ($type) {
			case "int":
			$value = ($value != "") ? intval($value) : NULL;
			break;
			default:
			$value = ($value != "") ? "'" . $value . "'" : "''";
		}
		return $value;
	}
	function register_user($first_login, $first_password, $confirm_password, $first_name, $first_info, $first_email) {
	  global $config;
	  global $link;
		if ($this->check_new_password($first_password, $confirm_password)) {
			if (strlen($first_login) >= LOGIN_LENGTH) {
				if ($this->check_email($first_email)) {
					$this->user_email = $first_email;
					$this->user = $first_login;
					if ($this->check_user("new")) {
						$this->the_msg = $this->messages(12);
					} else {
						$sql = sprintf("INSERT INTO %s (id, login, pw, real_name, extra_info, email, access_level, active) VALUES (NULL, %s, %s, %s, %s, %s, %d, 'n')", 
							$this->table_name,
							$this->ins_string($first_login),
							$this->ins_string(md5($first_password)),
							$this->ins_string($first_name),
							$this->ins_string($first_info),
							$this->ins_string($this->user_email),
							DEFAULT_ACCESS_LEVEL);
						$ins_res = $link->query($sql);
						if ($ins_res) {
							$this->id = mysqli_insert_id($link);
							$link->query("INSERT INTO `blocks` VALUES (NULL,'header','index',0,0,900,72,0,".$this->id.",';#FFFFFF;#000000;#000000;#666666;#FF6600'),(NULL,'player','video',1,1,".$config['blockLwidth'].",250,1,".$this->id.",NULL),(NULL,'video_comments','video',1,2,".$config['blockLwidth'].",80,1,".$this->id.",NULL),(NULL,'latest_videos','video',2,1,".$config['blockRwidth'].",100,1,".$this->id.",NULL),(NULL,'categories','video',2,2,".$config['blockRwidth'].",100,1,".$this->id.",NULL),(NULL,'same_cat','video',2,3,".$config['blockRwidth'].",100,1,".$this->id.",NULL),(NULL,'same_author','video',2,4,".$config['blockRwidth'].",100,1,".$this->id.",NULL),(NULL,'same_keywords','video',2,5,".$config['blockRwidth'].",100,1,".$this->id.",NULL),(NULL,'friend_channels','video',2,6,".$config['blockRwidth'].",100,1,".$this->id.",NULL),(NULL,'latest_on_friend_channels','video',2,7,".$config['blockRwidth'].",100,1,".$this->id.",NULL),(NULL,'most_viewed','video',2,8,".$config['blockRwidth'].",100,1,".$this->id.",NULL),(NULL,'favorites','video',2,9,".$config['blockRwidth'].",100,1,".$this->id.",NULL),(NULL,'playlists','video',2,10,".$config['blockRwidth'].",100,1,".$this->id.",NULL);");
							$this->user_pw = $first_password;
							if ($this->send_mail($this->user_email)) {
								$this->the_msg = $this->messages(13);
							} else {
								$link->query(sprintf("DELETE FROM %s WHERE id = %s", $this->table_name, $this->id));
								$this->the_msg = $this->messages(14);
							}
						} else {
							$this->the_msg = $this->messages(15);
						}
					}
				} else {
					$this->the_msg = $this->messages(16);
				}
			} else {
				$this->the_msg = $this->messages(17);
			}
		}
	}
	function validate_email($validation_key, $key_id) {
           global $link;
		if ($validation_key != "" && strlen($validation_key) == 32 && $key_id > 0) {
			$this->id = $key_id;
			if ($this->check_user("validate")) {
				$upd_sql = sprintf("UPDATE %s SET email = tmp_mail, tmp_mail = '' WHERE id = %d AND pw = '%s'", $this->table_name, $key_id, $validation_key);
				if ($link->query($upd_sql)) {
					$this->the_msg = $this->messages(18);
				} else {
					$this->the_msg = $this->messages(19);
				}
			} else {
				$this->the_msg = $this->messages(34);
			}
		} else {
			$this->the_msg = $this->messages(21);
		}
	}
	function activate_account($activate_key, $key_id) {
           global $link;
		if ($activate_key != "" && strlen($activate_key) == 32 && $key_id > 0) {
			$this->id = $key_id;
			if ($this->check_user("active")) {
				if ($this->auto_activation) {
					$upd_sql = sprintf("UPDATE %s SET active = 'y' WHERE id = %s AND pw = '%s'", $this->table_name, $key_id, $activate_key);
					if ($link->query($upd_sql)) {
						if ($this->send_confirmation($key_id)) {
							$this->the_msg = $this->messages(18);
						} else {
							$this->the_msg = $this->messages(14);
						}
					} else {
						$this->the_msg = $this->messages(19);
					}
				} else {
					if ($this->send_mail($this->admin_mail, 0, true)) {
						$this->the_msg = $this->messages(36);
					} else {
						$this->the_msg = $this->messages(14);
					}
				}
			} else {
				$this->the_msg = $this->messages(20);
			}
		} else {
			$this->the_msg = $this->messages(21);
		}
	}
	function send_confirmation($id) {
           global $link;
		//$sql = sprintf("SELECT email FROM %s WHERE id = %d", $this->table_name, $id);
		//$user_email = mysqli_result($link->query($sql), 0, "email");
		//if ($this->send_mail($user_email, 37)) {
			return true;
		//} else {
		//	return false;
		//}
	}
	function send_mail($mail_address, $num = 29) {
		$header = "From: \"".$this->webmaster_name."\" <".$this->webmaster_mail.">\r\n";
		if (!$this->auto_activation) {
			$subject = "New user request...";
			$body = "New user registration on ".date("Y-m-d").":\r\n\r\nClick here to enter the admin page:\r\n\r\n"."http://".$_SERVER['HTTP_HOST'].$this->admin_page."?login_id=".$this->id;
		} else {
			$subject = $this->messages(28);
			$body = $this->messages($num);
		}
		$body .= "\r\n\r\nGISS team";
		if (mail($mail_address, $subject, $body, $header)) {
			return true;
		} else {
			return false;
		} 
	}
	function forgot_password($forgot_email) { 
           global $link;
		if ($this->check_email($forgot_email)) {
			$this->user_email = $forgot_email;
			if (!$this->check_user("lost")) {
				$this->the_msg = $this->messages(22);
			} else {
				$forgot_sql = sprintf("SELECT id, pw FROM %s WHERE email = '%s'", $this->table_name, $this->user_email);
				if ($forgot_result = $link->query($forgot_sql)) {
					$this->id = mysqli_result($forgot_result, 0, "id");
					$this->user_pw = mysqli_result($forgot_result, 0, "pw");
					if ($this->send_mail($this->user_email, 35)) {
						$this->the_msg = $this->messages(23);
					} else {
						$this->the_msg = $this->messages(14);
					}
				} else {
					$this->the_msg = $this->messages(15);
				}
			}
		} else {
			$this->the_msg = $this->messages(16);
		}
	}
	function check_activation_password($controle_str, $id) {
           global $link;
		if ($controle_str != "" && strlen($controle_str) == 32 && $id > 0) {
			$this->user_pw = $controle_str;
			$this->id = $id;
			if ($this->check_user("new_pass")) {
				// this is a fix for version 1.76
				$sql_get_user = sprintf("SELECT login FROM %s WHERE pw = '%s' AND id = %d", $this->table_name, $this->user_pw, $this->id);
				$get_user = $link->query($sql_get_user);
				$this->user = mysqli_result($get_user, 0, "login"); // end fix
				return true;
			} else {
				$this->the_msg = $this->messages(21);
				return false;
			}
		} else {
			$this->the_msg = $this->messages(21);
			return false;
		}
	}
	function activate_new_password($new_pass, $new_confirm, $old_pass, $user_id) {
           global $link;
		if ($this->check_new_password($new_pass, $new_confirm)) {
			$sql_new_pass = sprintf("UPDATE %s SET pw = '%s' WHERE pw = '%s' AND id = %d", $this->table_name, md5($new_pass), $old_pass, $user_id);
			if ($link->query($sql_new_pass)) {
				$this->the_msg = $this->messages(30);
				return true;
			} else {
				$this->the_msg = $this->messages(14);
				return false;
			}
		} else {
			return false;
		}
	}
	function messages($num) {
		global $config;
		$host = "http://".$_SERVER['HTTP_HOST'];
		switch ($config['language']) {
			case "de":           
			$msg[10] = "Login und/oder Passwort finden keinen Treffer in der Datenbank.";
			$msg[11] = "Login und/oder Passwort sind leer!";
			$msg[12] = "Leider existiert bereits ein Benutzer mit diesem Login und/oder E-mailadresse.";
			$msg[13] = "Weitere Anweisungen wurden per E-mail versandt, folgen Sie nun den Instruktionen.";
			$msg[14] = "Es is ein Fehler entstanden probieren Sie es erneut.";
			$msg[15] = "Es is ein Fehler entstanden probieren Sie es spter nochmal.";
			$msg[16] = "Die eingegebene E-mailadresse ist nicht gltig.";
			$msg[17] = "Das Feld login (min. ".LOGIN_LENGTH." Zeichen) muss eingegeben sein.";
			$msg[18] = "Ihr Benutzerkonto ist aktiv. Sie knnen sich nun anmelden.<script language=javascript>window.location='./".$this->user."';</script>";
			$msg[19] = "Ihr Aktivierungs ist nicht gltig.";
			$msg[20] = "Da ist kein Konto zu aktivieren.";
			$msg[21] = "Der benutzte Aktivierung-Code is nicht gltig!";
			$msg[22] = "Keine Konto gefunden dass mit der eingegeben E-mailadresse bereinkommt.";
			$msg[23] = "Kontrollieren Sie Ihre E-Mail um Ihr neues Passwort zu erhalten.";
			$msg[25] = "Kann Ihr Passwort nicht aktivieren.";
			$msg[26] = "";
			$msg[27] = "Kontrollieren Sie Ihre E-Mailbox und besttigen Sie Ihre nderung(en).";
			$msg[28] = "Ihre Anfrage besttigen...";
			$msg[29] = "Hallo,\r\n\r\num Ihre Anfrage zu aktivieren klicken Sie bitte auf den folgenden Link:\r\n".$host.$this->login_page."?ident=".$this->id."&activate=".md5($this->user_pw)."&language=".$this->language;
			$msg[30] = "Ihre nderung ist durchgefhrt.<script language=javascript>window.location='./".$this->user."';</script>";
			$msg[31] = "Diese E-mailadresse wird bereits genutzt, bitte whlen Sie eine andere.";
			$msg[32] = "Das Feld Passwort (min. ".PW_LENGTH." Zeichen) muss eingegeben sein.";
			$msg[33] = "Hallo,\r\n\r\nIhre neue E-mailadresse muss noch berprft werden, bitte klicken Sie auf den folgenden Link:\r\n".$host.$this->login_page."?id=".$this->id."&validate=".md5($this->user_pw)."&language=".$this->language;
			$msg[34] = "Da ist keine E-mailadresse zu berprfen.";
			$msg[35] = "Hallo,\r\n\r\nIhr neues Passwort kann nun eingegeben werden, bitte klicken Sie auf den folgenden Link:\r\n".$host.$this->password_page."?id=".$this->id."&activate=".$this->user_pw."&language=".$this->language;
			$msg[36] = "Ihr Antrag ist verarbeitet und wird nun durch den Administrator kontrolliert. \r\nSie erhalten eine Nachricht wenn dies geschehen ist.";
			$msg[37] = "Hallo ".$this->user.",\r\n\r\nIhr Konto ist nun eigerichtet und Sie knnen sich anmelden.\r\n\r\nKlicken Sie hierfr auf den folgenden Link:\r\n".$host.$this->login_page."\r\n\r\nmit freundlichen Grssen\r\n".$this->admin_name;
			$msg[38] = "Das best&auml;tigte Passwort hat keine &Uuml;bereinstimmung mit dem ersten Passwort, bitte probieren Sie es erneut.";
			break;
			case "nl":
			$msg[10] = "Gebruikersnaam en/of wachtwoord vinden geen overeenkomst in de database.";
			$msg[11] = "Gebruikersnaam en/of wachtwoord zijn leeg!";
			$msg[12] = "Helaas bestaat er al een gebruiker met deze gebruikersnaam en/of e-mail adres.";
			$msg[13] = "Er is een e-mail is aan u verzonden, volg de instructies die daarin vermeld staan.";
			$msg[14] = "Het is een fout ontstaan, probeer het opnieuw.";
			$msg[15] = "Het is een fout ontstaan, probeer het later nog een keer.";
			$msg[16] = "De opgegeven e-mail adres is niet geldig.";
			$msg[17] = "De gebruikersnaam (min. ".LOGIN_LENGTH." teken) moet opgegeven zijn.";
			$msg[18] = "Het gebruikersaccount is aangemaakt, u kunt u nu aanmelden.<script language=javascript>window.location='./".$this->user."';</script>";
			$msg[19] = "Kan uw account niet activeren.";
			$msg[20] = "Er is geen account te activeren.";
			$msg[21] = "De gebruikte activeringscode is niet geldig!";
			$msg[22] = "Geen account gevonden dat met de opgegeven e-mail adres overeenkomt.";
			$msg[23] = "Er is een e-mail is aan u verzonden, daarin staat hoe uw een nieuw wachtwoord kunt aanmaken.";
			$msg[25] = "Kan het wachtwoord niet activeren.";
			$msg[26] = "";
			$msg[27] = "Er is een e-mail is aan u verzonden, volg de instructies die daarin vermeld staan.";
			$msg[28] = "Bevestig uw aanvraag ...";
			$msg[29] = "Bedankt voor uw aanvraag,\r\n\r\nklik op de volgende link om de aanvraag te verwerken:\r\n".$host.$this->login_page."?ident=".$this->id."&activate=".md5($this->user_pw)."&language=".$this->language;
			$msg[30] = "Uw wijzigingen zijn doorgevoerd.<script language=javascript>window.location='./".$this->user."';</script>";
			$msg[31] = "Dit e-mailadres bestaat al, gebruik en andere.";
			$msg[32] = "Het veld wachtwoord (min. ".PW_LENGTH." teken) mag niet leeg zijn.";
			$msg[33] = "Beste gebruiker,\r\n\r\nde nieuwe e-mailadres moet nog gevalideerd worden, klik hiervoor op de volgende link:\r\n".$host.$this->login_page."?id=".$this->id."&validate=".md5($this->user_pw)."&language=".$this->language;
			$msg[34] = "Er is geen e-mailadres te valideren.";
			$msg[35] = "Hallo,\r\n\r\nuw nieuw wachtwoord kan nu ingevoerd worden, klik op deze link om verder te gaan:\r\n".$host.$this->password_page."?id=".$this->id."&activate=".$this->user_pw."&language=".$this->language;
			$msg[36] = "U aanvraag is verwerkt en wordt door de beheerder binnenkort activeert. \r\nU krijgt bericht wanneer dit gebeurt is.";
			$msg[37] = "Hallo ".$this->user.",\r\n\r\nHet account is nu gereed en u kunt zich aanmelden.\r\n\r\nKlik hiervoor op de volgende link:\r\n".$host.$this->login_page."\r\n\r\nmet vriendelijke groet\r\n".$this->admin_name;
			$msg[38] = "Het bevestigings wachtwoord komt niet overeen met het wachtwoord, probeer het opnieuw.";
			break;
			case "fr":
			$msg[10] = "Le login et/ou mot de passe ne correspondent pas.";
			$msg[11] = "Le login et/ou mot de passe est vide !";
			$msg[12] = "Dsol, un utilisateur avec le mme email et/ou login existe dj.";
			$msg[13] = "Vrifiez votre email et suivez les instructions.";
			$msg[14] = "Dsol, une erreur s'est produite. Veuillez ressayer.";
			$msg[15] = "Dsol, une erreur s'est produite. Veuillez ressayer plus tard.";
			$msg[16] = "L'adresse email n'est pas valide.";
			$msg[17] = "Le champ \"Nom d'usager\" doit tre compos d'au moins ".LOGIN_LENGTH." caratres.";
			$msg[18] = "Votre requete est complte. Enregistrez vous pour continuer.<script language=javascript>window.location='./".$this->user."';</script>";
			$msg[19] = "Dsol, nous ne pouvons pas activer votre account.";
			$msg[20] = "Dsol, il n'y  pas d'account  activer.";
			$msg[21] = "Dsol, votre clef d'authorisation n'est pas valide";
			$msg[22] = "Dsol, il n'y  pas d'account actif avec cette adresse email.";
			$msg[23] = "Veuillez consulter votre email pour changer votre mot de passe.";
			$msg[25] = "Dsol, nous ne pouvons pas activer votre mot de passe.";
			$msg[26] = "";
			$msg[27] = "Veuillez consulter votre email pour activer les modifications.";
			$msg[28] = "Votre requete doit etre excuter...";
			$msg[29] = "Bonjour,\r\n\r\npour activer votre account clickez sur le lien suivant:\r\n".$host.$this->login_page."?ident=".$this->id."&activate=".md5($this->user_pw)."&language=".$this->language;
			$msg[30] = "Votre account  t modifi.<script language=javascript>window.location='./".$this->user."';</script>";
			$msg[31] = "Dsol, cette adresse email existe dj, veuillez en utiliser une autre.";
			$msg[32] = "Le champ password (min. ".PW_LENGTH." char) est requis.";
			$msg[33] = "Bonjour,\r\n\r\nvotre nouvelle adresse email doit tre valide, clickez sur le liens suivant:\r\n".$host.$this->login_page."?id=".$this->id."&validate=".md5($this->user_pw)."&language=".$this->language;
			$msg[34] = "Il n'y  pas d'email  valider.";
			$msg[35] = "Bonjour,\r\n\r\nPour entrer votre nouveaux mot de passe, clickez sur le lien suivant:\r\n".$host.$this->password_page."?id=".$this->id."&activate=".$this->user_pw."&language=".$this->language;
			$msg[36] = "Votre demande a t bien traite et d'ici peu l'administrateur va l 'activer. Nous vous informerons quand ceci est arriv.";
			$msg[37] = "Bonjour ".$this->user.",\r\n\r\nVotre compte est maintenant actif et il est possible d'y avoir accs.\r\n\r\nCliquez sur le lien suivant afin de rejoindre la page d'accs:\r\n".$host.$this->login_page."\r\n\r\nCordialement\r\n".$this->admin_name;
			$msg[38] = "Le mot de passe de confirmation de concorde pas avec votre mot de passe. Veuillez ressayer";
			break;
			case "en":
			$msg[10] = "Login and/or passord don't match.";
			$msg[11] = "Bad login and/or password !";
			$msg[12] = "Error, there is already a user with the same login or email address.";
			$msg[13] = "Check your email and follow the instructions.";
			$msg[14] = "There is an error, try it again.";
			$msg[15] = "There is an error, try it again later.";
			$msg[16] = "Email address not valid.";
			$msg[17] = "The \"username\" field (min. ".LOGIN_LENGTH." char.) is madatori.";
			$msg[18] = "Your petition is complete. register to continue. <script language=javascript>window.location='./".$this->user."';</script>";
			$msg[19] = "Error, your account can't be activated.";
			$msg[20] = "Error, there is no account to activate.";
			$msg[21] = "Error, your activation key is not valid!";
			$msg[22] = "Error, there is no active account with this email address.";
			$msg[23] = "Check your email to set a new password for your account.";
			$msg[25] = "Error, your email address can't be activated.";
			$msg[26] = ""; // not used at the moment
			$msg[27] = "Please check your e-mail and activate your modification(s).";
			$msg[28] = "Your request is pending...";
			$msg[29] = "Hello, your account at ".SITE." is pending activation.\n\nRegistered data:\nusername: ".$this->user."\npassword: ".$this->user_pw."\nemail address: ".$this->user_email."\n\n\nPlease, click on the following link to activate:  \n".$this->activate_acount_page."?ident=".$this->id."&activate=".md5($this->user_pw)."&language=".$this->language."\n\n";
			$msg[30] = "Your account has been modified. <script language=javascript>window.location='./".$this->user."';</script>";
			$msg[31] = "Error, there is already a user with the same email address. Please, use another one.";
			$msg[32] = "The \"password\" field (min. ".PW_LENGTH." char) is madatori.";
			$msg[33] = "Hello,\r\n\r\n, your new email address  is pending activation.\n\n Please, click on the following link to activate it: \r\n".$this->login_page."?id=".$this->id."&validate=".md5($this->user_pw)."&language=".$this->language;
			$msg[34] = "There is no email address pending validation.";
			$msg[35] = "Hello,\r\n\r\nto change your password on ".SITE." click on the following link:\r\n".$this->password_page."?id=".$this->id."&activate=".$this->user_pw."&language=".$this->language;
			$msg[36] = "Your request is processed and is pending for validation by the admin. \r\nYou will get an e-mail if it's done.";
			$msg[37] = "Hello ".$this->user.",\r\n\r\nThe account is active and it's possible to login now.\r\n\r\nClick on this link to access the login page:\r\n".$host.$this->login_page."\r\n\r\nkind regards\r\n".$this->admin_name;
			$msg[38] = "Your password is not correct, Try again.";
			break;

			default:
			$msg[10] = "Error d'acc&eacute;s!";
			$msg[11] = "Error d'acc&eacute;s!";
			$msg[12] = "Error, ja hi ha un usuari amb el mateix nom o adre&ccedil;a.";
			$msg[13] = "T'hem enviat un correu, segueix-ne les instruccions.";
			$msg[14] = "Hi ha hagut un error, torna-ho a provar.";
			$msg[15] = "Hi ha hagut un error, torna-ho a provar.";
			$msg[16] = "Adre&ccedil;a no valida.";
			$msg[17] = "El camp usuari (min. ".LOGIN_LENGTH." char.) es obligatori.";
			$msg[18] = "La teva peticio s'ha processat correctament. Ja pots accedir al teu compte.<script language=javascript>window.location='./".$this->user."';</script>";
			$msg[19] = "No s'ha pogut activar aquest compte.";
			$msg[20] = "No hi ha comptes per activar. Aquesta petici&oacute; ja va ser processada.";
			$msg[21] = "La clau d'activaci no s correcte!";
			$msg[22] = "Adre&ccedil;a no registrada.";
			$msg[23] = "T'hem enviat un correu per a cambiar la teva contrasenya.";
			$msg[25] = "No es pot activar el password.";
			$msg[26] = ""; // not used at the moment
			$msg[27] = "Please check your e-mail and activate your modifikation(s).";
			$msg[28] = "[".SITE."] gesti d'usuari pendent de confirmaci...";
			$msg[29] = "El teu registre s'ha processat correctament i ja pots accedir com usuari/a a ".SITE."\n\nDades registrades:\nnom d'usuari: ".$this->user."\ncontrasenya: ".$this->user_pw."\nadrea electrnica: ".$this->user_email."\n\nClica el segent enlla i ves a LOGIN on ja podrs entrar com usuari/a:  \n".$this->activate_acount_page."?ident=".$this->id."&activate=".md5($this->user_pw)."&language=".$this->language."\n\n";
			$msg[30] = "El teu compte es valid. <script language=javascript>window.location='./".$this->user."';</script>";
			$msg[31] = "Aquest correu ja existeix. Utilitza'n un altre.";
			$msg[32] = "El camp password (min. ".PW_LENGTH." char) es obligatori.";
			$msg[33] = "Hola,\r\n\r\nel nou e-mail ha de ser validat, visita el seguent link:\r\n".$this->login_page."?id=".$this->id."&validate=".md5($this->user_pw)."&language=".$this->language;
			$msg[34] = "No hi ha emails per a validar.";
			$msg[35] = "Hola,\r\n\r\nPer a cambiar la teva contrasenya a ".SITE.", visita el seguent link:\r\n".$this->password_page."?id=".$this->id."&activate=".$this->user_pw."&language=".$this->language;
			$msg[36] = "Your request is processed and is pending for validation by the admin. \r\nYou will get an e-mail if it's done.";
			$msg[37] = "Hello ".$this->user.",\r\n\r\nThe account is active and it's possible to login now.\r\n\r\nClick on this link to access the login page:\r\n".$host.$this->login_page."\r\n\r\nkind regards\r\n".$this->admin_name;
			$msg[38] = "El password no es correcte. Prova altre cop.";
		}
		return $msg[$num];
	}
}
?>
