#!/usr/bin/perl -w

use utf8;
my $inFile = shift;
$inFile =~ s/\%([A-Fa-f0-9]{2})/pack('C', hex($1))/seg;

if ( !$inFile )
{
   print "usage : get-duration.pl <infile>\n";
   exit -1;
}

if ( ! ( -f $inFile ) )
{
   print "0\n";
   exit -1;
}

if ( $inFile =~ /.flv/ )
{
  my @lengths = `ffmpeg -i \"$inFile\" 2>&1 | grep Duration`;
  my $duration;
  my @fields;
  my $dfield;
  my @hms;
  my $dhms;
  foreach $length (@lengths) {
   chop( $length);
   $duration=0;
   @fields = split(/ /, $length);
   foreach $dfield (@fields) {

      if ( $dfield =~ m/\d*:\d*:\d*/ )
      {
	@hms = split(/\./, $dfield );
	$dfield=$hms[0];
	@hms = split(/:/, $dfield );
	if ( $#hms == 0 ) # ss
	{
	   $duration = int($hms[0]+0.0);
	}
	if ( $#hms == 1 ) # mm:ss
	{
	   $duration = int( $hms[0]*60 + $hms[1]);
	}
	if ( $#hms == 2 ) # hh:mm:ss
	{
	   $duration = int( $hms[0]*3600 + $hms[1]*60 + $hms[2] );
	}
	print $duration."\n";
        exit 0;
      }
   }
  }
}
else
{
  my $length = `ffprobe -v error -show_entries format=duration -of default=noprint_wrappers=1:nokey=1 \"$inFile\"`;
  print $length."\n";
}

