#!/usr/bin/perl -w

use utf8;
my $oggFile = shift;
$oggFile =~ s/\%([A-Fa-f0-9]{2})/pack('C', hex($1))/seg;

if ( !$oggFile )
{
   print "usage : get-audiobitrate.pl <file>\n";
   exit -1;
}

if ( ! ( -f $oggFile ) )
{
   print "0\n";
   exit -1;
}

my $rate = `ffprobe -v error -select_streams v:0 -show_entries stream=bit_rate -of default=noprint_wrappers=1:nokey=1 \"$oggFile\"`;

if ( $rate eq "N/A" || $rate eq "" )
{
   print '0';
}
else
{
   print $rate/1024;
}
