<?php
require_once("../../../config.php");
require_once("../../../functions.php");
require_once("../../../classes/access_user/access_user_class.php");

$act_user = new Access_user;

/**
* Receive uploaded file and clean up temp files
*/
function receive($sid) {

    global $tmp_dir,$config;
    global $videoformat, $audioformat, $videobitrate, $audiobitrate, $thumbnail;

        $sid = spreg_replace("[^a-zA-Z0-9]","",$sid);
        $file = $tmp_dir.'/'.$sid.'_qstring';
        if(!file_exists($file)) {
                return false;
        }
        $qstr = join("",file($file));
        unlink("$tmp_dir/{$sid}_qstring");

        $q = array();
        parse_str($qstr,$q);
        
        $files = array();
        $num_files = count($q['file']['name']);
        for($i=0;$i<$num_files;$i++) 
        {
            $fn = $q['file']['name'][$i];
          $fn = stripslashes($fn);
          $b_pos = strrpos($fn, '\\');
          $f_pos = strrpos($fn, '/');
          if($b_pos == false and $f_pos == false) {
                  $file_name = $fn;
          } else {
                  $file_name = substr($fn, max($b_pos,$f_pos)+1);
          }

          // error_log( "fn :".$fn." file_name :".$file_name );

          // for duplicates
          if (file_exists($config['upload_dir']."/$file_name")) $append=rand();
          else $append="";
          $file_name = $append.$file_name;

            rename($q['file']['tmp_name'][$i], $config['upload_dir']."/$file_name");
          error_log( "renaming : ".$q['file']['tmp_name'][$i]." to :".$config['upload_dir']."/$file_name" );

          $d_pos=strrpos($file_name, '.');
          if ($d_pos === false) 
          {
               rename( $config['upload_dir']."/$file_name", $config['upload_dir']."/$file_name.avi");
             $file_name=$file_name.'.avi'; // fake extension
             $extension='.avi';
          }
        }

        return $file_name;
}

function pre_encode($file_name, $user) {

    global $tmp_dir,$config;
    global $videoformat, $audioformat, $videobitrate, $audiobitrate, $thumbnail;

       $d_pos=strrpos($file_name, '.');
       $bfile_name=substr($file_name, 0, $d_pos );
       $extension=substr($file_name, $d_pos+1,3);

          $resultENC = db_query ("SELECT encode_ogg, width_ogg_lq, aspect_ogg_lq, rate_ogg_lq, vqual_ogg_lq, arate_ogg_lq, achan_ogg_lq, aqual_ogg_lq FROM users WHERE login=\"$user\";");
          $eoptions = mysqli_fetch_row($resultENC); 

          $width_ogg_lq = $eoptions[1];
          switch ( $eoptions[2] )
          {
              case '4:3' :
                $height_ogg_lq = (int) $width_ogg_lq*3/4;
                break;

              case '16:9' :
                $height_ogg_lq = (int) $width_ogg_lq*9/16;
                break;

              case '1:1' :
                $height_ogg_lq = $width_ogg_lq;
                break;

              default :
                $height_ogg_lq = (int) $width_ogg_lq*3/4;
                break;
          }

          if ( $eoptions[0]=="y" ) 
          {

            $mfile_name="$file_name";
            $convcommand=$config['ffmpeg_bin']." -y -i \"".$config['upload_dir']."/$mfile_name\" -t 30 \"".$config['upload_dir'].$bfile_name."-tmp.ogg\" > /dev/null 2>&1";
            error_log( $convcommand );
            exec( $convcommand );
            $vfcommand=$config['rootdir']."/get-videoformat.pl \"".$config['upload_dir'].$bfile_name."-tmp.ogg\"";
            $ad = array();
            exec( $vfcommand, $ad );
            $videoformat=$ad[0];
            $afcommand=$config['rootdir']."/get-audioformat.pl \"".$config['upload_dir'].$bfile_name."-tmp.ogg\"";
            $ad = array();
            exec( $afcommand, $ad );
            $audioformat=$ad[0];
            $vbcommand=$config['rootdir']."/get-videobitrate.pl \"".$config['upload_dir'].$bfile_name."-tmp.ogg\"";
            $ad = array();
            exec( $vbcommand, $ad );
            $videobitrate=$ad[0];
            if ( ( $videobitrate == "nan" ) || ( $videobitrate == "" ) ) $videobitrate=0;
            $abcommand=$config['rootdir']."/get-audiobitrate.pl \"".$config['upload_dir'].$bfile_name."-tmp.ogg\"";
            $ad = array();
            exec( $abcommand, $ad );
            $audiobitrate=$ad[0];
            if ( ( $audiobitrate == "nan" ) || ( $audiobitrate == "" ) ) $audiobitrate=0;
            error_log( "received : videoformat=".$videoformat." audioformat=".$audioformat." videobitrate=".$videobitrate." audiobitrate=".$audiobitrate  );
            unlink( $config['upload_dir'].$bfile_name."-tmp.ogg" );
          }
          else
          {
            $mfile_name="$file_name";
          }
        
          if ( $videoformat != 'unknown' )
          {
             $thumbcommand=$config['ffmpeg_bin']." -y -i \"".$config['upload_dir']."/$mfile_name\" -f mjpeg -ss 1 -vframes 1 -s 160x120 -an \"".$config['upload_dir']."/$bfile_name".".jpg\"; echo \$?";
             error_log( $thumbcommand );
             $result = exec( $thumbcommand );
             if ( $result == 0 )
             {
                $thumbnail="contents/".$bfile_name.".jpg";
             }
             else
             {
                error_log('could not extract thumbnail' );
                $thumbnail="contents/video.png";
             }
          }
          else
          {
             $thumbcommand=$config['audiowaveform_bin']." -z auto --waveform-color 00ff00 --background-color 000000 -i \"".$config['upload_dir']."/$mfile_name\" -o \"".$config['upload_dir']."/$bfile_name".".png\"; echo \$?";
             error_log( $thumbcommand );
             $result = exec( $thumbcommand );
             if ( $result == 0 )
             {
                $thumbnail="contents/".$bfile_name.".png";
             }
             else
             {
                error_log('could not extract thumbnail' );
                $thumbnail="contents/sound.png";
             }
          }

          return $mfile_name;

}


function encode($file_name, $user) {

    global $tmp_dir,$config;
    global $videoformat, $audioformat, $videobitrate, $audiobitrate, $thumbnail;

       $d_pos=strrpos($file_name, '.');
       $bfile_name=substr($file_name, 0, $d_pos );
       $extension=substr($file_name, $d_pos+1,3);

          $resultENC = db_query ("SELECT encode_ogg, width_ogg_lq, aspect_ogg_lq, rate_ogg_lq, vqual_ogg_lq, arate_ogg_lq, achan_ogg_lq, aqual_ogg_lq, width_ogg_hq, aspect_ogg_hq, rate_ogg_hq, vqual_ogg_hq, arate_ogg_hq, achan_ogg_hq, aqual_ogg_hq, encode_mp4, width_mp4_lq, aspect_mp4_lq, rate_mp4_lq, bitrate_mp4_lq, arate_mp4_lq, achan_mp4_lq, width_mp4_hq, aspect_mp4_hq, rate_mp4_hq, bitrate_mp4_hq, arate_mp4_hq, achan_mp4_hq  FROM users WHERE login=\"$user\";");
          $eoptions = mysqli_fetch_row($resultENC); 

          $width_ogg_lq = $eoptions[1];
          switch ( $eoptions[2] )
          {
              case '4:3' :
                $height_ogg_lq = (int) $width_ogg_lq*3/4;
                break;

              case '16:9' :
                $height_ogg_lq = (int) $width_ogg_lq*9/16;
                break;

              case '1:1' :
                $height_ogg_lq = $width_ogg_lq;
                break;

              default :
                $height_ogg_lq = (int) $width_ogg_lq*3/4;
                break;
          }

          $width_ogg_hq = $eoptions[8];
          switch ( $eoptions[9] )
          {
              case '4:3' :
                $height_ogg_hq = (int) $width_ogg_hq*3/4;
                break;

              case '16:9' :
                $height_ogg_hq = (int) $width_ogg_hq*9/16;
                break;

              case '1:1' :
                $height_ogg_hq = $width_ogg_hq;
                break;

              default :
                $height_ogg_hq = (int) $width_ogg_hq*3/4;
                break;
          }

          $width_mp4_lq = $eoptions[16];
          switch ( $eoptions[17] )
          {
              case '4:3' :
                $height_mp4_lq = (int) $width_mp4_lq*3/4;
                break;

              case '16:9' :
                $height_mp4_lq = (int) $width_mp4_lq*9/16;
                break;

              case '1:1' :
                $height_mp4_lq = $width_mp4_lq;
                break;

              default :
                $height_mp4_lq = (int) $width_mp4_lq*3/4;
                break;
          }

          $width_mp4_hq = $eoptions[22];
          switch ( $eoptions[23] )
          {
              case '4:3' :
                $height_mp4_hq = (int) $width_mp4_hq*3/4;
                break;

              case '16:9' :
                $height_mp4_hq = (int) $width_mp4_hq*9/16;
                break;

              case '1:1' :
                $height_mp4_hq = $width_mp4_hq;
                break;

              default :
                $height_mp4_hq = (int) $width_mp4_hq*3/4;
                break;
          }

          if ( $eoptions[0]=="y" ) 
          {
             $convcommand=$config['ffmpeg_bin']." -y -i \"".$config['upload_dir']."/$file_name\" -r ".$eoptions[3]." -acodec ".$config['acodec']." -ac 2 -aq ".$eoptions[7]." -vcodec ".$config['vcodec']." -s ".$width_ogg_lq."x".$height_ogg_lq." -aspect ".$eoptions[2]." \"".$config['upload_dir']."/".$bfile_name."-ol.".$config['container']."\" > /dev/null 2>&1 &";
             error_log( $convcommand );
             exec( $convcommand );
          }

          if ( $eoptions[15]=="y" )
          {
             $convcommand=$config['ffmpeg_bin']." -y -i \"".$config['upload_dir']."/$file_name\" -acodec libvorbis -ac ".$eoptions[21]." -ar ".$eoptions[20]." -vcodec libx264 -vpre fast -r ".$eoptions[18]." -b ".$eoptions[19]." -s ".$width_mp4_lq."x".$height_mp4_lq." -aspect ".$eoptions[17]." \"".$config['upload_dir']."/".$bfile_name."-ol.mp4\" > /dev/null 2>&1 &";
             error_log( $convcommand );
             exec( $convcommand );
          }

          if ( $eoptions[0]=="y" ) 
          {
             $convcommand=$config['ffmpeg_bin']." -y -i \"".$config['upload_dir']."/$file_name\" -r ".$eoptions[10]." -acodec ".$config['acodec']." -ac 2 -aq ".$eoptions[14]." -vcodec ".$config['vcodec']." -s ".$width_ogg_lq."x".$height_ogg_lq." -aspect ".$eoptions[2]." \"".$config['upload_dir']."/".$bfile_name."-dl.".$config['container']."\" > /dev/null 2>&1 &";
              error_log( $convcommand );
              exec( $convcommand );
          }

          if ( $eoptions[15]=="y" )
          {
             $convcommand=$config['ffmpeg_bin']." -y -i \"".$config['upload_dir']."/$file_name\" -acodec libvorbis -ac ".$eoptions[27]." -ar ".$eoptions[26]." -vcodec libx264 -vpre fast -r ".$eoptions[24]." -b ".$eoptions[25]." -s ".$width_mp4_hq."x".$height_mp4_hq." -aspect ".$eoptions[23]." \"".$config['upload_dir']."/".$bfile_name."-dl.mp4\" > /dev/null 2>&1 &";
             error_log( $convcommand );
             exec( $convcommand );
          }
}

function redirect($file_name, $user) {

    global $tmp_dir,$config;
    global $videoformat, $audioformat, $videobitrate, $audiobitrate, $thumbnail;

          if ($_GET['w']!="") 
          {
           echo "<html>
                 <head>
                 <script>
                  function goParent() {
                    top.location.assign(\"".$config['siteurl']."/admin/?mod=video&op=updatefile&ID=".$_GET['ID']."&url=".urlencode($file_name)."&thumbnail=".urlencode($thumbnail)."&videoformat=".$videoformat."&audioformat=".$audioformat."&videobitrate=".$videobitrate."&audiobitrate=".$audiobitrate."\");
                  }
                 </script>
                 </head>
                 <body onload='goParent();'>
                 </body>
                 </html>";
          }
          else 
          {
           echo "<html>
                 <head>
                 <script>
                  function goParent() {
                    top.location.assign(\"".$config['siteurl'] ."/admin/?mod=video&op=newdocuform&url=".urlencode($file_name)."&thumbnail=".urlencode($thumbnail)."&videoformat=".$videoformat."&audioformat=".$audioformat."&videobitrate=".$videobitrate."&audiobitrate=".$audiobitrate."\");
                  }
                 </script>
                 </head>
                 <body onload='goParent();'>
                 </body>
                 </html>";
          }
}

//
// Clean up temporary files
//
function cleanup($sid) {
   global $tmp_dir;
   $files = array("_flength","_postdata","_err","_signal");
   foreach($files as $file) {
     if(file_exists("$tmp_dir/$sid$file")) {
       unlink("$tmp_dir/$sid$file");
     }
   }
}

// only really used for .ogg format
$videoformat="unknown";
$audioformat="unknown";
$videobitrate=0;
$audiobitrate=0;
$thumbnail='';

$sid = $_GET['file_1'];

$user = $_SESSION['user'];

if ( !$user || ( $user == '' ) )
{
   echo "
         <script>
         function errorUpload(msg) {
            top.document.getElementById('upload_message').innerHTML='<div style=\'color:red;\'>'+msg+'</div>';
         }
         errorUpload('Session has been lost... <br/>Sorry for the inconvenience...<br/>Reconnect please and retry.');
         </script>
         ";
   exit(-1);
}

$file_name = receive($sid,$user);
$file_name = pre_encode($file_name,$user);
encode($file_name,$user);
cleanup($sid);
redirect($file_name,$user);

?>
